#include <windows.h>
#include <atlbase.h>
#include <atlwin.h>
#include <atltypes.h>
#include <atlcom.h>
#include <d3d9.h>
#include <d3dx9.h>
#include <tchar.h>
#include <dwmapi.h>
#include <list>

#pragma comment (lib, "dwmapi.lib")
#pragma comment(lib, "d3d9.lib")

// DirectX 9.L p D3DX ͂܂񋟂ĂȂ߁C
// CuƂ̃N͔
#if defined( USE_D3DX_LIB )
#if !defined ( _RELEASE )
  #pragma comment(lib, "d3dx9d.lib")
#else
  #pragma comment(lib, "d3dx9.lib")
#endif
#endif

typedef CComPtr<IDirect3D9Ex>            IDirect3D9ExPtr;
typedef CComPtr<IDirect3DDevice9Ex>      IDirect3DDevice9ExPtr;
typedef CComPtr<IDirect3DIndexBuffer9>   IDirect3DIndexBuffer9Ptr;
typedef CComPtr<IDirect3DVertexDeclaration9>   IDirect3DVertexDeclaration9Ptr;
typedef CComPtr<IDirect3DResource9>      IDirect3DResource9Ptr;
typedef CComPtr<IDirect3DSurface9>       IDirect3DSurface9Ptr;
typedef CComPtr<IDirect3DSwapChain9>     IDirect3DSwapChain9Ptr;
typedef CComPtr<IDirect3DTexture9>       IDirect3DTexture9Ptr;
typedef CComPtr<IDirect3DVertexBuffer9>  IDirect3DVertexBuffer9Ptr;
typedef CComPtr<IDirect3DVolume9>        IDirect3DVolume9Ptr;
typedef CComPtr<IDirect3DVolumeTexture9> IDirect3DVolumeTexture9Ptr;
typedef CComPtr<IDirect3DStateBlock9>    IDirect3DStateBlock9Ptr;

//-----------------------------------------------------------------------------
// WinMain
//-----------------------------------------------------------------------------
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE, LPSTR, int );

//-----------------------------------------------------------------------------
// WindowNX
//-----------------------------------------------------------------------------
class CMyWindow : public CWindowImpl<CMyWindow>
{
public:

	BEGIN_MSG_MAP( CGameWindow )
		MESSAGE_HANDLER( WM_SYSCOMMAND,  OnSysCommand )
		MESSAGE_HANDLER( WM_NCHITTEST, OnNCHitTest )
		MESSAGE_HANDLER( WM_CREATE,       OnCreate )
		MESSAGE_HANDLER( WM_KEYDOWN,     OnKeyDown )
		MESSAGE_HANDLER( WM_DESTROY,     OnDestroy )
		MESSAGE_HANDLER( WM_ERASEBKGND,  OnEraseBkgnd )
	END_MSG_MAP()

	static const int BottomRegionSize = 90;

	CMyWindow()
	{
	}

	LRESULT OnCreate( UINT msg, WPARAM wParam, LPARAM lParam, BOOL& isHandled )
	{
		m_brush = (HBRUSH)CreateSolidBrush(0x00000000);
		m_font = CreateFontW(128, 
					0,
					310,
					0,
					FW_BOLD,
					FALSE,
					FALSE,
					FALSE,
					DEFAULT_CHARSET,
					OUT_DEFAULT_PRECIS,
					CLIP_DEFAULT_PRECIS,
					PROOF_QUALITY,
					0,
					L"CI");
		EnableBlurBehind();
		return 0;
	}

		//-------------------------------------------------------------------------
	// OnNCHitTest handler
	//-------------------------------------------------------------------------
	LRESULT OnNCHitTest( UINT msg, WPARAM wParam, LPARAM lParam, BOOL& isHandled )
	{
		isHandled = true;
		return HTCAPTION;
	}

	//-------------------------------------------------------------------------
	// OnSysCommand handler
	//-------------------------------------------------------------------------
	LRESULT OnSysCommand( UINT msg, WPARAM wParam, LPARAM lParam, BOOL& isHandled )
	{
		switch (wParam & 0xFFF0)
		{
		  case SC_SCREENSAVE:
		  case SC_MONITORPOWER:
			// XN[Z[o & ȓd̓[h
			return 0;
		}
		// DefaultWindowProc ɗꍇ́CisHandled  false ɂ
		isHandled = false;
		return 0;
	}

	//-------------------------------------------------------------------------
	// OnKeyDown handler
	//-------------------------------------------------------------------------
	LRESULT OnKeyDown( UINT msg, WPARAM wParam, LPARAM lParam, BOOL& isHandled )
	{
		// ESC ŏI
		if(wParam == VK_ESCAPE)
		{
			DestroyWindow();
		}
		return 0;
	}

	//-------------------------------------------------------------------------
	// OnDestroy handler
	//-------------------------------------------------------------------------
	LRESULT OnDestroy( UINT msg, WPARAM wParam, LPARAM lParam, BOOL& isHandled )
	{
		DeleteObject( m_brush );
		m_brush = NULL;
		DeleteObject( m_font );
		m_font = NULL;
		PostQuitMessage(0);
		return 0;
	}
	HBRUSH m_brush;
	HFONT m_font;
	//-------------------------------------------------------------------------
	// OnEraseBkgnd handler
	//-------------------------------------------------------------------------
	LRESULT OnEraseBkgnd( UINT msg, WPARAM wParam, LPARAM lParam, BOOL& bHandled )
	{
		HDC hdc = (HDC) wParam;

		CRect rect;
		GetClientRect( &rect );
		FillRect( hdc, &rect, m_brush );

		bHandled = true;
		return 1;
	}

	HRESULT EnableBlurBehind()
	{
		HRESULT hr = S_OK;

		DWM_BLURBEHIND bb = {0};
		bb.dwFlags = DWM_BB_ENABLE | DWM_BB_BLURREGION;
		bb.fEnable = true;

		{
				BOOL ret;
				HDC hdc = CreateCompatibleDC(NULL);
				HBITMAP bmp = CreateCompatibleBitmap(NULL, 640, 480 );
				HBITMAP oldBmp = (HBITMAP) SelectObject( hdc, bmp );
				HFONT oldFont = (HFONT) SelectObject( hdc, m_font );
				SetBkMode(hdc, TRANSPARENT); 
				SetPolyFillMode(hdc, ALTERNATE);

				ret = BeginPath(hdc);
				ret = TextOutW(hdc, 10, 300, L"Windows Vista", wcslen(L"Windows Vista") );
				ret = EndPath(hdc);
				BYTE type[1024] = {0};
				POINT points[1024];
				int num = GetPath(hdc, points, type, 1024 );
				HRGN rgn = PathToRegion(hdc);

				HRGN rgn2 = CreateEllipticRgn(160, 40, 480, 360 );
				int error = CombineRgn( rgn, rgn2, rgn, RGN_XOR );

				SelectObject( hdc, oldBmp );
				SelectObject( hdc, oldFont );
				DeleteObject( bmp );
				DeleteObject( rgn2 );
				DeleteDC(hdc);

				bb.hRgnBlur = rgn;
			}

		hr = DwmEnableBlurBehindWindow(m_hWnd, &bb);

		MARGINS mgn = {0};
		mgn.cyBottomHeight = BottomRegionSize;
		hr = DwmExtendFrameIntoClientArea( m_hWnd, &mgn );
		return hr;
	}

	//-------------------------------------------------------------------------
	// ProcessMessage
	//-------------------------------------------------------------------------
	bool ProcessMessage(WPARAM& uiRetCode)
	{
		MSG msg;
		ZeroMemory( &msg, sizeof(MSG) );
		while( ::PeekMessage(&msg, NULL, 0U, 0U, PM_REMOVE) )
		{
			if(WM_QUIT == msg.message)
			{
				uiRetCode = msg.wParam;
				return false;
			}
			::TranslateMessage(&msg);
			::DispatchMessage(&msg);
		}
		return true;
	}
};

struct CUSTOMVERTEX
{
    D3DXVECTOR4 Position;
    DWORD Color;
	static const int FVF = D3DFVF_XYZRHW|D3DFVF_DIFFUSE;
};

inline float RandFloat()
{
	return ((float)rand() / RAND_MAX);
}

struct Tri
{
	CUSTOMVERTEX  vertices[3];
	D3DXVECTOR4    speed;
	Tri()
	{
		D3DXVECTOR4 center( -100.0f, RandFloat() * 480.0f, 0.2f, 1.0f );
		const float alpha = 0.2f + 0.8f * RandFloat();
		for( int i = 0; i < 3; ++i )
		{
			vertices[i].Position = center + D3DXVECTOR4( RandFloat() * 200.0f - 100.0f, RandFloat() * 200.0f- 100.0f, 0.0f, 0.0f );
			vertices[i].Color = D3DXCOLOR( 0.5f, 0.5f , 1.0f, alpha );
		}
		speed = D3DXVECTOR4( 2.0f + 5.0f * RandFloat(), -1.0f + 2.0f * RandFloat(), 0.0f, 0.0f );
	}
	void Update()
	{
		for( int i = 0; i < 3; ++i )
		{
			vertices[i].Position += speed;
		}
	}
	void Draw( IDirect3DDevice9ExPtr device )
	{
		HRESULT ret = device->DrawPrimitiveUP( D3DPT_TRIANGLEFAN, 1, vertices, sizeof(CUSTOMVERTEX) );
	}
};


//-----------------------------------------------------------------------------
// WinMain
//-----------------------------------------------------------------------------
int WINAPI _tWinMain( HINSTANCE hInstance, HINSTANCE, LPTSTR, int )
{
	// ATLW[
	CAtlWinModule module;
	{
		// IR[h
		WPARAM uiRetCode = 0;
		
		// COM 
		CoInitializeEx( NULL, COINIT_MULTITHREADED );

		// Window 쐬
		CMyWindow window;
		window.Create( NULL, CWindow::rcDefault,
				_T("DrectX9.L Test"), WS_CAPTION | WS_SYSMENU | WS_OVERLAPPED | WS_MINIMIZEBOX  );

		// sɂꉞIʂ߂ return  break 邱
		while(true)
		{
#if defined( USE_D3DX_LIB )
			if( !D3DXCheckVersion( D3D_SDK_VERSION, D3DX_SDK_VERSION ) )
			{
				break;
			}
#endif
			IDirect3D9ExPtr d3d9;
			if( FAILED( Direct3DCreate9Ex( D3D_SDK_VERSION, &d3d9 ) ))
			{
				break;
			}

			D3DPRESENT_PARAMETERS d3dpp;
			ZeroMemory( &d3dpp, sizeof(d3dpp) );
			d3dpp.Windowed = TRUE;
			d3dpp.BackBufferWidth = 640;
			d3dpp.BackBufferHeight = 480;
			d3dpp.EnableAutoDepthStencil = TRUE;
			d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
			d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
			d3dpp.BackBufferFormat = D3DFMT_A8R8G8B8;

			IDirect3DDevice9ExPtr device;
			if( FAILED(
				d3d9->CreateDeviceEx(
					D3DADAPTER_DEFAULT,
					D3DDEVTYPE_HAL,
					window.m_hWnd,
					D3DCREATE_HARDWARE_VERTEXPROCESSING,
					&d3dpp,
					NULL,
					&device ) ) )
			{
				return E_FAIL;
			}

			// NCAg̈̃TCYύX
			window.ResizeClient( 640, 480, FALSE );
			
			// Z^O
			window.CenterWindow();
						
			// EBhE\
			window.ShowWindow( SW_SHOW );

			window.SetWindowPos(HWND_TOPMOST, &CRect(), SWP_NOMOVE | SWP_NOSIZE);
			
			// 1 bZ[W
			if( !window.ProcessMessage(uiRetCode) )
			{
				break;
			}

			device->SetFVF( CUSTOMVERTEX::FVF );
			device->SetRenderState( D3DRS_CULLMODE, D3DCULL_NONE );
			device->SetRenderState( D3DRS_ZENABLE, D3DZB_FALSE );
			device->SetTextureStageState( 0, D3DTSS_ALPHAOP, D3DTOP_SELECTARG2 );
			device->SetTextureStageState( 0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE );

			std::list<Tri> triangles;

			//// CbZ[W[v
			while( window.ProcessMessage(uiRetCode) )
			{
				device->Clear(0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, D3DCOLOR_ARGB(0,0,0,0), 1.0f, 0 );

				if( triangles.size() < 16 )
				{
					triangles.push_back(Tri());
				}

				if( SUCCEEDED( device->BeginScene() ) )
				{
					CUSTOMVERTEX bg[6];
					bg[0].Position = D3DXVECTOR4( 640.0f, 195.0f, 0.5f, 1.0f );
					bg[1].Position = D3DXVECTOR4( 640.0f, 390.0f, 0.5f, 1.0f );
					bg[2].Position = D3DXVECTOR4( 320.0f, 390.0f, 0.5f, 1.0f );
					bg[3].Position = D3DXVECTOR4( 0.0f, 0.0f, 0.5f, 1.0f );
					bg[4].Position = D3DXVECTOR4( 320.0f, 0.0f, 0.5f, 1.0f );
					bg[5].Position = D3DXVECTOR4( 0.0f, 195.0f, 0.5f, 1.0f );

					bg[0].Color = D3DXCOLOR( 1.0f, 0.0f, 0.0f, 0.2f );
					bg[1].Color = D3DXCOLOR( 1.0f, 0.0f, 0.0f, 0.2f );
					bg[2].Color = D3DXCOLOR( 1.0f, 0.0f, 0.0f, 0.2f );
					bg[3].Color = D3DXCOLOR( 1.0f, 1.0f, 0.0f, 0.2f );
					bg[4].Color = D3DXCOLOR( 1.0f, 1.0f, 0.0f, 0.2f );
					bg[5].Color = D3DXCOLOR( 1.0f, 1.0f, 0.0f, 0.2f );

					HRESULT ret = device->DrawPrimitiveUP( D3DPT_TRIANGLELIST, 2, bg, sizeof(CUSTOMVERTEX) );

					for( std::list<Tri>::iterator i = triangles.begin(); i != triangles.end(); )
					{
						i->Update();
						i->Draw( device );
						if( i->vertices[0].Position.x > 700.0f )
						{
							i = triangles.erase(i);
						}
						else
						{
							++i;
						}						
					}

					device->EndScene();
				}
				device->Present( NULL, NULL, NULL,  NULL );
				Sleep( 16 );
           }
			
			// bZ[W[vI
			break;
		}

		CoUninitialize();

		return (INT) uiRetCode;
	}
}
